package com.tuoheng.service.impl;

import com.sun.deploy.util.StringUtils;
import com.tuoheng.mapper.AuthoritiesMapper;
import com.tuoheng.mapper.UserMapper;
import com.tuoheng.model.param.CreateUserDto;
import com.tuoheng.model.po.AuthoritiesPo;
import com.tuoheng.model.po.UserPo;
import com.tuoheng.service.UserSevice;
import com.tuoheng.until.JsonResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.provisioning.UserDetailsManager;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author chenjiandong
 * @description: TODO
 * @date 2022/10/8 11:35
 */
@Service
public class UserServiceImpl implements UserSevice {

    @Autowired
    private UserMapper userMapper;

    @Autowired
    private AuthoritiesMapper authoritiesMapper;

    @Transactional(rollbackFor = Exception.class)
    public JsonResult createUser(CreateUserDto createUserDto){
        UserPo userPo = new UserPo()
                .setUsername(createUserDto.getUsername())
                .setPassword("{bcrypt}" + new BCryptPasswordEncoder().encode(createUserDto.getPassword()));
        userMapper.insertUser(userPo);
        String roles = StringUtils.join(createUserDto.getRoles(),",");

        AuthoritiesPo authoritiesPo = new AuthoritiesPo()
                .setUserId(userPo.getId())
                .setUsername(createUserDto.getUsername())
                .setAuthority(roles);
        authoritiesMapper.insertAuthorities(authoritiesPo);
        return JsonResult.success(userPo.getId());
    }

}
